jQuery(document).ready(function($){
	
	function gaCarousel(id) {
		
		this.carousel;
		this.project;
		this.imgWidth;
		this.imgHeight;
		this.id = "#"+id;
		this.itemWidth;
		this.totalWidth;
		this.projectWidth;
		this.carouselWidth;
		this.configCarouselWidth = "100%";
		this.configProjectWidth = "150";
		this.projectsQtt;
		this.autoplay = true;
		this.autoplaydelay;
		this.autoplayTimer;
		this.roll;
		this.navigation;
		this.direction;
		this.duration;
		this.caption;
		this.captionH;
		this.animation;
		this.proportionX;
		this.proportionY;
		this.easing = "linear";
		this.border;
		this.borderR;
		this.borderC;
		this.margin;
		this.nav;
		this.customStyle;
		var self = this;
		
		this.init = function() { 
			
			this.carousel = $(this.id);
			this.project = $(this.id+' .ga-project');
			this.roll = $(this.id+' .ga-roll');
			this.navigation = $(this.id+' .ga-navigation');
			this.w = String(this.carousel.data("width"));
			this.a = this.carousel.data("autoplay");
			this.d = this.carousel.data("direction");
			this.dl = this.carousel.data("delay");
			this.du = this.carousel.data("duration");
			this.pw = String(this.carousel.data("width-item"));
			this.pr = this.carousel.data("proportion");
			this.an = this.carousel.data("animation");
			this.cp = this.carousel.data("caption");
			this.b = this.carousel.data("border");
			this.bc = this.carousel.data("border-color");
			this.br = this.carousel.data("border-radius");
			this.mr = this.carousel.data("margin");
			this.nv = this.carousel.data("navigation");
			
			if(typeof this.b != "undefined"){this.border = this.b;}
			if(typeof this.bc != "undefined"){this.borderC = this.bc;}
			if(typeof this.br != "undefined"){this.borderR = this.br;}
			if(typeof this.mr != "undefined"){this.margin = this.mr;}
			if(typeof this.nv != "undefined"){this.nav = this.nv;}
			
			if(typeof this.dl == "undefined"){this.autoplaydelay = 5000;}else{this.autoplaydelay = this.dl*1000;}
			if(typeof this.du == "undefined"){this.duration = 400;}else{this.duration = this.du*1000;}
			if(typeof this.cp == "undefined"){this.caption = 1;}else{this.caption = this.cp;}
			if(typeof this.an == "undefined"){this.animation = "bysection";}else{this.animation = this.an;}
			if(typeof this.pr == "undefined"){this.proportionX = "1";this.proportionY = "1";}else{if(this.pr == "auto"){this.proportionX="auto";this.proportionY="auto";}else{var prop = this.pr.split(":");this.proportionX = prop[0];this.proportionY = prop[1];}}
			if(this.a==0){this.autoplay=false;};
			if(this.d=="left"){this.direction="+";}else{this.direction="-";};
			if(this.w != "undefined"){if(this.w.indexOf('%') + 1){this.configCarouselWidth = this.w;}else{if(this.w.indexOf('px') + 1){this.configCarouselWidth=this.w;}else{this.configCarouselWidth=this.w+"px";}}};
			if(this.pw != "undefined"){if(this.pw.indexOf('%') + 1){this.configProjectWidth = this.pw;}else{if(this.pw.indexOf('px') + 1){this.configProjectWidth=this.pw.replace("px", "");}else{this.configProjectWidth=this.pw;}}};
			
			this.imgWidth = this.carousel.data("imgwidth");
			this.imgHeight = this.carousel.data("imgheight");
			
			createCustomCSS.call(this);			
			
			this.carouselWidth = this.carousel.width();
			this.projectWidth = this.project.outerWidth() + parseInt(this.project.css('margin-right').replace('px',''));
			this.projectsQtt = this.project.size();
			this.totalWidth = (this.projectWidth*this.projectsQtt-this.carouselWidth);					
			
			if (this.totalWidth > 0){
				
				scrollDragDetect.call(this);			
				
				if(this.autoplay){startAnimation();}		
				
				this.navigation.on('click touchstart', function(){			
					clearInterval(self.autoplayTimer);				
					if (this.id == "ga-nav-left") { 
						scrollToSection("+");
					}
					else  {
						scrollToSection('-');
					}
				});
			}
			
			$(window).resize(function() {});
			
		}
		
		function startAnimation (){
			
			if (self.animation == "bysection"){				
				self.autoplayTimer = setInterval(function(){scrollToSection(self.direction)}, self.autoplaydelay);				
			}
			if (self.animation == "linear"){				
				self.autoplayTimer = setInterval(function(){changePosition(self.direction, 1)}, self.duration/20);				
			}
			
		}
		
		function createCustomCSS() {
			
			var proportion;
			var imgH;
			var imgW;
			var addheight = 0;
			var addProject ='';
			var addP ='';
			
			this.captionH=$(this.id+' .ga-project p').outerHeight(true);
			
			if (typeof this.border != "undefined"){

				addProject +="border-width:"+this.border+"px;";
				
				if (typeof this.borderC != "undefined"){
				
					addProject +="border-color:"+this.borderC+";";
					addP +="background:"+this.borderC+";";
					}
					
				if (typeof this.borderR != "undefined"){
				
					if (this.borderR != 0){
					
						if(!this.borderR.indexOf('%'))
						{this.borderR = this.borderR+"px";}						
						
						}
					
					addProject +="border-radius:"+this.borderR+";-webkit-border-radius:"+this.borderR+";-moz-border-radius:"+this.borderR+";";
					
					}
				
				}
				
				if (typeof this.margin != "undefined"){
				
					addProject +="margin-right:"+this.margin+"px;";
					
					}
					
				if (this.nav == 0){
				
					$(this.id).find('.ga-navigation').hide();
					
					}
			
			if (this.proportionX == "auto"){
				
				proportion = this.imgWidth/this.imgHeight;
				
				}else{
				
				proportion = this.proportionX/this.proportionY;
				
			}
			
			if (this.captionH != null){
				
				addheight = this.captionH;
			}
			
			this.customStyle = "<style>";
			
			if (proportion == 1){
				
				this.customStyle += this.id+" .ga-project div{width:"+this.configProjectWidth+"px;height:"+this.configProjectWidth+"px}";
				this.customStyle += this.id+" .ga-project {width:"+this.configProjectWidth+"px;height:"+(Number(this.configProjectWidth)+Number(addheight))+"px;"+addProject+"}";
				imgH = this.configProjectWidth+"px";
				imgW = "auto";
				this.customStyle += this.id+" .ga-project img {height:"+imgH+";width:"+imgW+";}";
				}else{
				
				if (proportion > 1){
					
					imgH = Number(this.configProjectWidth/proportion)+Number(addheight)+"px";
					imgW = this.configProjectWidth+"px";
					
					this.customStyle += this.id+" .ga-project div{width:"+this.configProjectWidth+"px;height:"+imgH+";}";
					this.customStyle += this.id+" .ga-project{width:"+this.configProjectWidth+"px;height:"+imgH+";"+addProject+"}";
					this.customStyle += this.id+" .ga-project img {min-height:100%;width:"+imgW+";}";
					}else{
					
					imgH = Number(this.configProjectWidth/proportion)+Number(addheight)+"px";
					imgW = "auto";
					this.customStyle += this.id+" .ga-project div{width:"+this.configProjectWidth+"px;height:"+imgH+";}";
					this.customStyle += this.id+" .ga-project {width:"+this.configProjectWidth+"px;height:"+imgH+";"+addProject+"}";
					this.customStyle += this.id+" .ga-project img {height:"+imgH+";width:"+imgW+";}";
				}
				
			}			
			this.customStyle += this.id+" .ga-project p{"+addP+"}";
			this.customStyle +="</style>";  
			$('head').append(this.customStyle);
			
		}
		
		function scrollDragDetect() {
			
			var drag = false;
			var previousOffset = 0;
			
			var $links = $(this.id+' [data-fancybox]');
			
			if(typeof $.fancybox != 'function') {
				
				$links.on('click touchstart', function() {
					$.fancybox.open( $links, {
					}, $links.index( this ) );
					
					return false;
				});
				
			}
			
			this.carousel.on('mousedown touchstart', function(event){
				event.preventDefault();
				event.stopPropagation();
				clearInterval(self.autoplayTimer);
				drag = true;			
				
			});
			
			$( "*" ).on('mouseup touchend', function(){
				drag = false;
				previousOffset = 0;
				
			});
			
			this.carousel.on('mousemove touchmove', function(event){
				
				var touch = undefined
				if (event.originalEvent.touches){touch = event.originalEvent.touches[0];}
				
				var pageX = event.pageX || touch.pageX;
				
				if(drag){
					
					if(previousOffset == 0){previousOffset = pageX}
					
					if(previousOffset > pageX){
						var offset = previousOffset - pageX;
						changePosition('-', offset);
						previousOffset = pageX;	
					}
					
					if(previousOffset < pageX){
						
						var offset = pageX - previousOffset;
						changePosition('+', offset);
						previousOffset = pageX;
						
					}		
					
				}
			});
			
		}
		
		function changePosition(direction, offset){
			
			var curposition = -1*(self.roll.css("left").replace('px',''));
			
			if(curposition < 0){
				self.roll.css({left:-self.projectWidth});
				self.roll.find( '.ga-project:first' ).before( $('.ga-project:last', self.roll) );	
			}
			if(curposition > self.totalWidth){			
				self.roll.css({left:-(self.totalWidth - self.projectWidth)});
				self.roll.find( '.ga-project:last' ).after( $('.ga-project:first', self.roll) );	
			}
			self.roll.css({left:direction+'='+offset});
			
		}
		function scrollToSection(direction) {
			
			var from = {property: 5};
			var to = {property: 10};
			var end = {property: 5};
			
			$(from).animate(to, {
				easing: self.easing,
				duration: self.duration,
				step: function() {changePosition(direction, this.property);},
				complete: function() {			
					$(to).animate(end, {			
						easing: self.easing,
						duration: self.duration,
					step: function() {changePosition(direction, this.property);}});				
					
				}
				
			});			
			
		}
	}
	
	$(".ga-carousel").each(function( i ) {	
		var id = "ga-id"+(i+1);
		var gaC = new Array();
		$(this).find(".ga-project a").attr( "data-fancybox", id );
		$(this).attr( "id", id);
		gaC[i] = new gaCarousel(id);
		gaC[i].init();	
		
	});
	
});